// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: gateway/users/v1/users.proto

package usersv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/gateway/pkg/gen/gateway/users/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// UsersServiceName is the fully-qualified name of the UsersService service.
	UsersServiceName = "gateway.users.v1.UsersService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// UsersServiceRegisterProcedure is the fully-qualified name of the UsersService's Register RPC.
	UsersServiceRegisterProcedure = "/gateway.users.v1.UsersService/Register"
	// UsersServiceEditSelfProcedure is the fully-qualified name of the UsersService's EditSelf RPC.
	UsersServiceEditSelfProcedure = "/gateway.users.v1.UsersService/EditSelf"
	// UsersServiceGetAllowedEmojisProcedure is the fully-qualified name of the UsersService's
	// GetAllowedEmojis RPC.
	UsersServiceGetAllowedEmojisProcedure = "/gateway.users.v1.UsersService/GetAllowedEmojis"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	usersServiceServiceDescriptor                = v1.File_gateway_users_v1_users_proto.Services().ByName("UsersService")
	usersServiceRegisterMethodDescriptor         = usersServiceServiceDescriptor.Methods().ByName("Register")
	usersServiceEditSelfMethodDescriptor         = usersServiceServiceDescriptor.Methods().ByName("EditSelf")
	usersServiceGetAllowedEmojisMethodDescriptor = usersServiceServiceDescriptor.Methods().ByName("GetAllowedEmojis")
)

// UsersServiceClient is a client for the gateway.users.v1.UsersService service.
type UsersServiceClient interface {
	// Registers a new user in the system, providing a unique id and private key for authentication.
	Register(context.Context, *connect.Request[v1.RegisterRequest]) (*connect.Response[v1.RegisterResponse], error)
	// Edits the authenticated user's details, such as their nickname and emoji.
	EditSelf(context.Context, *connect.Request[v1.EditSelfRequest]) (*connect.Response[v1.EditSelfResponse], error)
	// Retrieves a list of allowed emojis for users.
	GetAllowedEmojis(context.Context, *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error)
}

// NewUsersServiceClient constructs a client for the gateway.users.v1.UsersService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewUsersServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) UsersServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &usersServiceClient{
		register: connect.NewClient[v1.RegisterRequest, v1.RegisterResponse](
			httpClient,
			baseURL+UsersServiceRegisterProcedure,
			connect.WithSchema(usersServiceRegisterMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		editSelf: connect.NewClient[v1.EditSelfRequest, v1.EditSelfResponse](
			httpClient,
			baseURL+UsersServiceEditSelfProcedure,
			connect.WithSchema(usersServiceEditSelfMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getAllowedEmojis: connect.NewClient[v1.GetAllowedEmojisRequest, v1.GetAllowedEmojisResponse](
			httpClient,
			baseURL+UsersServiceGetAllowedEmojisProcedure,
			connect.WithSchema(usersServiceGetAllowedEmojisMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// usersServiceClient implements UsersServiceClient.
type usersServiceClient struct {
	register         *connect.Client[v1.RegisterRequest, v1.RegisterResponse]
	editSelf         *connect.Client[v1.EditSelfRequest, v1.EditSelfResponse]
	getAllowedEmojis *connect.Client[v1.GetAllowedEmojisRequest, v1.GetAllowedEmojisResponse]
}

// Register calls gateway.users.v1.UsersService.Register.
func (c *usersServiceClient) Register(ctx context.Context, req *connect.Request[v1.RegisterRequest]) (*connect.Response[v1.RegisterResponse], error) {
	return c.register.CallUnary(ctx, req)
}

// EditSelf calls gateway.users.v1.UsersService.EditSelf.
func (c *usersServiceClient) EditSelf(ctx context.Context, req *connect.Request[v1.EditSelfRequest]) (*connect.Response[v1.EditSelfResponse], error) {
	return c.editSelf.CallUnary(ctx, req)
}

// GetAllowedEmojis calls gateway.users.v1.UsersService.GetAllowedEmojis.
func (c *usersServiceClient) GetAllowedEmojis(ctx context.Context, req *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error) {
	return c.getAllowedEmojis.CallUnary(ctx, req)
}

// UsersServiceHandler is an implementation of the gateway.users.v1.UsersService service.
type UsersServiceHandler interface {
	// Registers a new user in the system, providing a unique id and private key for authentication.
	Register(context.Context, *connect.Request[v1.RegisterRequest]) (*connect.Response[v1.RegisterResponse], error)
	// Edits the authenticated user's details, such as their nickname and emoji.
	EditSelf(context.Context, *connect.Request[v1.EditSelfRequest]) (*connect.Response[v1.EditSelfResponse], error)
	// Retrieves a list of allowed emojis for users.
	GetAllowedEmojis(context.Context, *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error)
}

// NewUsersServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewUsersServiceHandler(svc UsersServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	usersServiceRegisterHandler := connect.NewUnaryHandler(
		UsersServiceRegisterProcedure,
		svc.Register,
		connect.WithSchema(usersServiceRegisterMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	usersServiceEditSelfHandler := connect.NewUnaryHandler(
		UsersServiceEditSelfProcedure,
		svc.EditSelf,
		connect.WithSchema(usersServiceEditSelfMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	usersServiceGetAllowedEmojisHandler := connect.NewUnaryHandler(
		UsersServiceGetAllowedEmojisProcedure,
		svc.GetAllowedEmojis,
		connect.WithSchema(usersServiceGetAllowedEmojisMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/gateway.users.v1.UsersService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case UsersServiceRegisterProcedure:
			usersServiceRegisterHandler.ServeHTTP(w, r)
		case UsersServiceEditSelfProcedure:
			usersServiceEditSelfHandler.ServeHTTP(w, r)
		case UsersServiceGetAllowedEmojisProcedure:
			usersServiceGetAllowedEmojisHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedUsersServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedUsersServiceHandler struct{}

func (UnimplementedUsersServiceHandler) Register(context.Context, *connect.Request[v1.RegisterRequest]) (*connect.Response[v1.RegisterResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.users.v1.UsersService.Register is not implemented"))
}

func (UnimplementedUsersServiceHandler) EditSelf(context.Context, *connect.Request[v1.EditSelfRequest]) (*connect.Response[v1.EditSelfResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.users.v1.UsersService.EditSelf is not implemented"))
}

func (UnimplementedUsersServiceHandler) GetAllowedEmojis(context.Context, *connect.Request[v1.GetAllowedEmojisRequest]) (*connect.Response[v1.GetAllowedEmojisResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.users.v1.UsersService.GetAllowedEmojis is not implemented"))
}
